const gulp = require('gulp'),
    spriteBuild = require('./task/spriteBuilder').buildIconSprites,
    scss = require('./task/scss').buildCSS,
    js = require('./task/js').build,
    gui = require('./task/jsonMinifier').build,
    worker = require('./task/worker').build;

gulp.task('scss', scss);
gulp.task('js', js);
gulp.task('sprite', spriteBuild);
gulp.task('gui', gui);
gulp.task('workerJS', worker);

gulp.task('watchMe', () => {
    gulp.watch('./../raw/javascript/**/*.js', gulp.series('js'));
    gulp.watch('./../raw/worker/**/*.js', gulp.series('workerJS'));
    gulp.watch('./../raw/scss/**/*.scss', gulp.series('scss'));
    gulp.watch('./../raw/gui/**/*.json', gulp.series('gui'));
});

gulp.task('default', gulp.parallel('js', 'scss', 'sprite', 'gui', 'workerJS'));

gulp.task('watch', gulp.parallel('js', 'scss', 'sprite', 'gui', 'workerJS', 'watchMe'));
